diff --git a/crypto/evp/p_lib.c b/crypto/evp/p_lib.c
index 339c1fe4dea2..5691fffae3a9 100644
--- a/crypto/evp/p_lib.c
+++ b/crypto/evp/p_lib.c
@@ -322,7 +322,7 @@ EVP_PKEY *EVP_PKEY_new_CMAC_key(ENGINE *e, const unsigned char *priv,
 {
 #ifndef OPENSSL_NO_CMAC
 # ifndef OPENSSL_NO_ENGINE
-    const char *engine_name = e != NULL ? ENGINE_get_name(e) : NULL;
+    const char *engine_id = e != NULL ? ENGINE_get_id(e) : NULL;
 # endif
     const char *cipher_name = EVP_CIPHER_name(cipher);
     const OSSL_PROVIDER *prov = EVP_CIPHER_provider(cipher);
@@ -342,11 +342,11 @@ EVP_PKEY *EVP_PKEY_new_CMAC_key(ENGINE *e, const unsigned char *priv,
     }
 
 # ifndef OPENSSL_NO_ENGINE
-    if (engine_name != NULL)
+    if (engine_id != NULL)
         params[paramsn++] =
             OSSL_PARAM_construct_utf8_string(OSSL_MAC_PARAM_ENGINE,
-                                             (char *)engine_name,
-                                             strlen(engine_name) + 1);
+                                             (char *)engine_id,
+                                             strlen(engine_id) + 1);
 # endif
 
     params[paramsn++] =
